diff options
author | Jim Meyering <jim@meyering.net> | 2003-01-07 15:34:20 +0000 |
---|---|---|
committer | Jim Meyering <jim@meyering.net> | 2003-01-07 15:34:20 +0000 |
commit | 8586d4652e8734987762277d3e754d9ac9d85eab (patch) | |
tree | 5ae5f9ae53f7505e7193f47214ef73f54cf1955c /tests/touch | |
parent | 0d07d1b2b7251d15803dcf6145457678660e7161 (diff) | |
download | coreutils-8586d4652e8734987762277d3e754d9ac9d85eab.tar.xz |
New test, mostly extracted from fail-diag.
Diffstat (limited to 'tests/touch')
-rwxr-xr-x | tests/touch/not-owner | 48 |
1 files changed, 48 insertions, 0 deletions
diff --git a/tests/touch/not-owner b/tests/touch/not-owner new file mode 100755 index 000000000..dc99928cd --- /dev/null +++ b/tests/touch/not-owner @@ -0,0 +1,48 @@ +#!/bin/sh +# Make sure that touch gives reasonable diagnostics when applied +# to an unwritable directory owned by some other user. + +if test "$VERBOSE" = yes; then + set -x + touch --version +fi + +. $srcdir/../envvar-check +. $srcdir/../lang-default +PRIV_CHECK_ARG=require-non-root . $srcdir/../priv-check + +pwd=`pwd` +tmp=fail-diag.$$ +trap 'status=$?; cd $pwd; rm -rf $tmp && exit $status' 0 +trap '(exit $?); exit' 1 2 13 15 + +framework_failure=0 +mkdir $tmp || framework_failure=1 +cd $tmp || framework_failure=1 + +if test $framework_failure = 1; then + echo 'failure in testing framework' 1>&2 + (exit 1); exit +fi + +fail=0 + +# Before fileutils-4.1, we'd get the following misleading +# diagnostic instead of `...: Permission denied'. +# touch: creating `/': Is a directory +touch / > out 2>&1 && fail=1 + +# On SunOS4, EPERM is `Not owner'. +# On some *BSD systems it's `Operation not permitted'. +for msg in 'Not owner' 'Operation not permitted' 'Permission denied'; do + cat > exp <<EOF +touch: setting times of \`/': $msg +EOF + + cmp out exp > /dev/null 2>&1 && { match=1; break; } +done +test "$match" = 1 || fail=1 + +test $fail = 1 && diff out exp 2> /dev/null + +(exit $fail); exit |